# -*- coding: utf-8 -*-

#1a) Un modo di combinare più liste in un'unica lista è il cosiddetto 
# "interleaving": il risultato si ottiene prendendo il primo elemento di 
# ciascuna lista in input, nell'ordine dato (se tale elemento esiste), poi il 
# secondo elemento di ciascuna lista in input (se tale elemento esiste), ecc., 
# fin quando tutti gli elementi siano stati considerati.
# Si scriva la funzione interleave(ll) che, data una lista di liste ll, 
# restituisca l'interleaving delle liste in ll.
#
# Es. 
# x, y, z = [1,2,3], ['A','B'], [None]
# 
# interleave([y,x])     # -> ['A', 1, 'B', 2, 3]
# interleave([x,z,y])   # -> [1, None, 'A', 2, 'B', 3]
# interleave([y])       # -> ['A', 'B']
#
# Opzionalmente, al posto della funzione si può scrivere un generatore 
# equivalente.


def interleave(ll):
    """
    Returns a list that is the interleaving of the lists passed as argument
    (inside the list ll).
    """ 
    res=[]
    for idx in xrange(0, max(len(l) for l in ll)):
        for l in ll:
            try:
                res.append( l[idx] )
            except IndexError:
                continue
    return res


def gen_interleave(ll):
    """
    Generator that returns element of a list that is the interleaving of the 
    lists passed as argument (inside the list ll).
    """ 
    for idx in xrange(0, max(len(l) for l in ll)):
        for l in ll:
            try:
                yield l[idx]
            except IndexError:
                continue


def rec_interleave(ll):
    """
    Possible recursive version of interleave().
    """ 
    minl = min(len(l) for l in ll)
    ll0, ll1 = [l[:minl] for l in ll], [l[minl:] for l in ll if l[minl:]]
    res = [x for y in zip(*ll0) for x in y] #tuples from zip() are flattened
    if ll1:
        res.extend(rec_interleave(ll1))
    return res

