# -*- coding: utf-8 -*-

#2a) Un ORF (Open Reading Frame) è una sequenza di codoni delimitata da una 
# sequenza start "ATG" e da uno dei codoni di stop "TAA", "TAG" e "TGA", senza
# nessun codone di stop al suo interno.
# Si scriva una funzione findFirstORF(s,i) che, presa in input una stringa s 
# che rappresenti una sequenza di DNA, e un indice i (con standard Python), 
# restituisca la stringa che corrisponde al primo ORF che si incontra a partire 
# dalla posizione i, e l'indice della posizione in cui tale ORF inizia.
# Nel caso in cui non venga trovato alcun ORF, si dovrà restituire "" e -1.
#
# Es. 
# x = "TATAAATGCTAGGATGCTTACGCTGATAGTATAGT"
# findFirstORF(x, 2)        # -> ('ATGCTAGGATGCTTACGCTGA', 5)
# findFirstORF(x, 6)        # -> ('ATGCTTACGCTGATAGTATAG', 13)
# findFirstORF(x, 14)       # -> ('', -1)


def findFirstORF(s,i):
    """
    Returns the first ORF in s found startig from position i, along with ther 
    relative position (index values starting from 0).
    """ 
    s = s[i:]
    stops = ["TAA","TAG","TGA"]
    start = "ATG"
    j = s.find(start)
    if j>=0:
        s=s[j:]
        poss=[]
        lens=len(s)
        for stop in stops:
            offset = 3
            while offset<lens:
                nextpos = s.find(stop, offset)
                if nextpos<0:
                    break;
                if not nextpos%3:
                    poss.append(nextpos)
                    break
                offset = nextpos+1
        if poss:
            pos = min(poss)
            return s[:pos+3], i+j
    return "", -1
 

           