# -*- coding: utf-8 -*-

#1b) Nei file Homo_sapiens_MB_201_exons.fasta e Homo_sapiens_MB_201_introns.fasta 
# sono contenute le sequenze degli esoni e degli introni relativi al gene della
# mioglobina umana.
# Si inseriscano le relative stringhe in due liste distinte, e si ricostruisca 
# la sequenza completa facendo uso della funzione sviluppata al punto 1a),
# salvandola in formato fasta sul file "uso1.txt".
# L'intestazione dovrà essere ">RISULTATO"; per questo, nella creazione del 
# relativo SeqRecord, occorre specificare name="", description="".


import Bio.SeqIO as SeqIO
from Bio.SeqRecord import SeqRecord
from Bio.Seq import Seq
from soluzione1 import interleave

infile1 = "Homo_sapiens_MB_201_exons.fasta"
infile2 = "Homo_sapiens_MB_201_introns.fasta"
outfile = "uso1.txt"

exons = [str(s.seq) for s in SeqIO.parse(infile1, format="fasta")]
introns = [str(s.seq) for s in SeqIO.parse(infile2, format="fasta")]

wholeseq = "".join( interleave([exons, introns]) )

with open(outfile, "w") as out_f:
    SeqIO.write([SeqRecord(Seq(wholeseq),"RISULTATO", name="", description="")], out_f, "fasta")

