# -*- coding: utf-8 -*-

#3b) Sfruttando il codice sviluppato al punto 3a), si costruisca un dizionario
# unused_codes, analogo ad aa2dna, in cui per ogni amminoacido sia fornita la 
# lista dei codici che NON sono usati per la codifica della mioglobina.
# Si scriva sul file uso3.txt la rappresentazione standard di unused_codes.
# La sequenza di amminoacidi della mioglobina è contenuta in myoglobin.fasta,
# e la relativa CDS in myoglobin_CDS.fasta.
# Nota: la copia y di un dizionario x può essere ottenuta con y = dict(x)


from soluzione3 import aa2dna
import Bio.SeqIO as SeqIO

file_aa  = "myoglobin.fasta"
file_cds = "myoglobin_CDS.fasta"
outfile  = "uso3.txt"

aa  = list(str(SeqIO.read(file_aa,  format="fasta").seq))
aa.append("STOP")

cds = str(SeqIO.read(file_cds, format="fasta").seq)
codings = [cds[i:i+3] for i in xrange(0, len(cds), 3)]

unused_codes = dict(aa2dna)

for k,v in zip(aa, codings):
    try:
        unused_codes[k].remove(v)
    except ValueError:
        pass
    
with open(outfile, "w") as f:
    f.write(str(unused_codes))

 