# -*- coding: utf-8 -*-

#4b) Conoscendo la sequenza di amminoacidi di una proteina e la porzione di DNA
# all'interno della quale è codificata (introni compresi), è possibile 
# avere indicazioni sul posizionamento degli introni.
# Si consideri la sequenza d corrispondente alla naturale concatenazione degli 
# esoni e degli introni del gene della mioglobina. Su di essa, usando la 
# funzione sviluppata in 3a), si determini la posizione del più lungo prefisso 
# della mioglobina per cui si riesce a trovare una corrispondenza su d.
# Si scrivano su due righe consecutive del file uso4.txt la posizione di 
# partenza del prefisso trovato, e il prefisso stesso.
# La sequenza di amminoacidi della mioglobina è contenuta in myoglobin.fasta.


from soluzione4 import find_prot
from soluzione1 import interleave
import Bio.SeqIO as SeqIO

infile_myogl   = "myoglobin.fasta"
infile_exons   = "Homo_sapiens_MB_201_exons.fasta"
infile_introns = "Homo_sapiens_MB_201_introns.fasta"
outfile  = "uso4.txt"

mg = str(SeqIO.read(infile_myogl, format="fasta").seq)

exons =   [str(s.seq) for s in SeqIO.parse(infile_exons,   format="fasta")]
introns = [str(s.seq) for s in SeqIO.parse(infile_introns, format="fasta")]

d = "".join( interleave([exons, introns]) )

# the maximal prefix is found though a dichotomic search
curr = upper = len(mg)
lower = 0

while upper-lower>1:
    i, m = find_prot(mg[:curr], d)
    if i<0: #i.e. match not found: we need to try a shorter prefix
        upper = curr
    else: #i.e. match found: we need to try a longer prefix
        lower = curr
    curr = (lower+upper)/2

with open(outfile, "w") as f:
    f.write(str(i)+"\n")
    f.write(m+"\n")

